<template>
  <div>
    <nav-bar></nav-bar>
    <div class="columns">
      <div class="column is-10 is-offset-1">
        <div class="columns">
          <div class="column">
            <label class="label is-size-2">Your Tasks: </label>
          </div>
        </div>



        <div class="columns" v-for="i in Math.ceil(numbTasks / 3)">
          <div class="column is-4"  v-for="item in tasks.slice((i - 1) * 3, i * 3)" v-show="current_user_id === item.user">

            <div class="card">
            <div class="card-header">
              <div class="card-header-title" v-if="!item.isEditing" style="padding-left: 25px">
                {{item.name}}
              </div>
              <div class="card-header-title" v-if="item.isEditing" style="padding-left: 25px">
                <input placeholder="Write new name" v-model="item.name"/>
              </div>
              <span class="icon" v-show="item.isDone" >
                  <i class="fa fa-check-circle "  style="font-size: 2rem; padding-right: 1rem; padding-top: 1rem"  ></i>
              </span>
              <span class="icon" v-show="item.isEditing" >
                  <i class="fa fa-floppy-o "  style="font-size: 2rem; padding-right: 1rem; padding-top: 1rem"  ></i>
              </span>
            </div>
            <div class="card-content" v-if="!item.isEditing">
              <div class="content">
                {{item.description}}
                <br>
                Time left: {{item.days}} Days
              </div>
            </div>
              <div class="card-content" v-if="item.isEditing">
                <div class="content">
                  <input v-model="item.description" placeholder="new description"/>
                  <br>
                  <input v-model="item.days" placeholder="Days to task"/>
                </div>
              </div>
            <footer class="card-footer">
              <a @click="saveTask(item)" class="card-footer-item">Done</a>
              <a @click="editTask(item)" class="card-footer-item">Edit</a>
              <a @click="deleteTask(item)" class="card-footer-item">Delete</a>
            </footer>
            </div>
          </div>
        </div>

      </div>
    </div>
  </div>
</template>

<script>
  import firebase from 'firebase'
  import axios from 'axios'
  import Navbar from './Navbar'
  import NavBar from "./Navbar.vue";

  export default {
    name: 'createTask',
    data: function () {
      return {
        name: '',
        type: '',
        user: '',
        state: '',
        current_user_id: '',
        users: '',
        tasks: [],
        numbTasks: '',
        currentUserName: ''
      }
    },
    components: {
      NavBar,
      'nav-bar': Navbar,
    },
    methods: {
      deleteTask(task) {
        console.log(task);
        let index = this.tasks.indexOf(task);
        this.tasks.splice(index, 1);
        firebase.database().ref("task/" + task.id).set(null);
      },
      editTask(task){
          let index = this.tasks.indexOf(task);
          task.isEditing = true;
          this.tasks.splice(index, 1);
          this.tasks.push(task);
          console.log(this.tasks[index].isEditing);
      },
      saveTask(task) {
        let index = this.tasks.indexOf(task);
        task.isEditing = false;
        task.isDone = true;
        this.tasks.splice(index, 1);
        this.tasks.push(task);
        firebase.database().ref("task/" + task.id).set(task);
        console.log(this.tasks[index].isEditing);
      }
    },
    mounted() {
        this.current_user_id = firebase.auth().currentUser.uid
      axios.get('https://unitask-604a4.firebaseio.com/users.json')
        .then(res => {
          this.users = res.data;
          for(var i =0; i < Object.keys(res.data).length;i++){
            if(this.current_user_id === res.data[i.toString()].id ){
              this.currentUserName = res.data[i.toString()].name
            }
          }
          }
        )
      axios.get('https://unitask-604a4.firebaseio.com/task.json')
        .then(res => {
          this.numbTasks = Object.keys(res.data).length;
          for(var i = 0; i < this.numbTasks; i++) {
            this.tasks.push(res.data[Object.keys(res.data)[i]])
            this.tasks[i].id = Object.keys(res.data)[i];
            this.tasks[i].isEditing = false;
            this.tasks[i].isDone = false;

          }
        })
    }
  }
</script>

<style scoped>
.fa-check-circle{
  color: forestgreen;
}
.fa-floppy-o {
   color: yellow;
 }
</style>
